// Copyright (C) 2001, 2002, 2003  EPITA Research and Development Laboratory
//
// This file is part of the Olena Library.  This library is free
// software; you can redistribute it and/or modify it under the terms
// of the GNU General Public License version 2 as published by the
// Free Software Foundation.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this library; see the file COPYING.  If not, write to
// the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
// Boston, MA 02110-1301, USA.
//
// As a special exception, you may use this file as part of a free
// software library without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to
// produce an executable, this file does not by itself cause the
// resulting executable to be covered by the GNU General Public
// License.  This exception does not however invalidate any other
// reasons why the executable file might be covered by the GNU General
// Public License.

#ifndef NTG_BASICS_HH
# define NTG_BASICS_HH

/*
  Basic header that regroup basic common headers every file
  will certainely need.
*/

# include <ntg/config/system.hh>

# include <ntg/core/predecls.hh>

# include <ntg/core/abstract_hierarchy.hh>
# include <ntg/real/behavior.hh>
# include <ntg/core/contract.hh>
# include <ntg/core/interval.hh>
# include <ntg/real/builtin_properties.hh>
# include <ntg/core/type.hh>
# include <ntg/core/value.hh>

/*
  These headers are included as builtins may be used anywhere, without
  having previously included the corresponding integre headers.
*/
# include <ntg/enum/builtin_bool.hh>
# include <ntg/real/builtin_int.hh>
# include <ntg/real/builtin_float.hh>

# include <ntg/core/internal/global_ops.hh>
# include <ntg/core/macros.hh>

# include <ntg/utils/cast.hh>

#endif // !NTG_BASICS_HH
